<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ProductDateModifiedArray ArrayType
 * @subpackage Arrays
 */
class ProductDateModifiedArray extends AbstractStructArrayBase
{
    /**
     * The ProductDateModified
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - ref: ns1:ProductDateModified
     * @var \StructType\ProductDateModified[]
     */
    public $ProductDateModified;
    /**
     * Constructor method for ProductDateModifiedArray
     * @uses ProductDateModifiedArray::setProductDateModified()
     * @param \StructType\ProductDateModified[] $productDateModified
     */
    public function __construct(array $productDateModified = array())
    {
        $this
            ->setProductDateModified($productDateModified);
    }
    /**
     * Get ProductDateModified value
     * @return \StructType\ProductDateModified[]|null
     */
    public function getProductDateModified()
    {
        return $this->ProductDateModified;
    }
    /**
     * This method is responsible for validating the values passed to the setProductDateModified method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProductDateModified method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProductDateModifiedForArrayConstraintsFromSetProductDateModified(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $productDateModifiedArrayProductDateModifiedItem) {
            // validation for constraint: itemType
            if (!$productDateModifiedArrayProductDateModifiedItem instanceof \StructType\ProductDateModified) {
                $invalidValues[] = is_object($productDateModifiedArrayProductDateModifiedItem) ? get_class($productDateModifiedArrayProductDateModifiedItem) : sprintf('%s(%s)', gettype($productDateModifiedArrayProductDateModifiedItem), var_export($productDateModifiedArrayProductDateModifiedItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProductDateModified property can only contain items of type \StructType\ProductDateModified, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProductDateModified value
     * @throws \InvalidArgumentException
     * @param \StructType\ProductDateModified[] $productDateModified
     * @return \ArrayType\ProductDateModifiedArray
     */
    public function setProductDateModified(array $productDateModified = array())
    {
        // validation for constraint: array
        if ('' !== ($productDateModifiedArrayErrorMessage = self::validateProductDateModifiedForArrayConstraintsFromSetProductDateModified($productDateModified))) {
            throw new \InvalidArgumentException($productDateModifiedArrayErrorMessage, __LINE__);
        }
        $this->ProductDateModified = $productDateModified;
        return $this;
    }
    /**
     * Add item to ProductDateModified value
     * @throws \InvalidArgumentException
     * @param \StructType\ProductDateModified $item
     * @return \ArrayType\ProductDateModifiedArray
     */
    public function addToProductDateModified(\StructType\ProductDateModified $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProductDateModified) {
            throw new \InvalidArgumentException(sprintf('The ProductDateModified property can only contain items of type \StructType\ProductDateModified, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProductDateModified[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProductDateModified|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProductDateModified|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProductDateModified|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProductDateModified|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProductDateModified|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProductDateModified
     */
    public function getAttributeName()
    {
        return 'ProductDateModified';
    }
}
