<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for SizeApparelArray ArrayType
 * @subpackage Arrays
 */
class SizeApparelArray extends AbstractStructArrayBase
{
    /**
     * The SizeApparel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\SizeApparel[]
     */
    public $SizeApparel;
    /**
     * Constructor method for SizeApparelArray
     * @uses SizeApparelArray::setSizeApparel()
     * @param \StructType\SizeApparel[] $sizeApparel
     */
    public function __construct(array $sizeApparel = array())
    {
        $this
            ->setSizeApparel($sizeApparel);
    }
    /**
     * Get SizeApparel value
     * @return \StructType\SizeApparel[]|null
     */
    public function getSizeApparel()
    {
        return $this->SizeApparel;
    }
    /**
     * This method is responsible for validating the values passed to the setSizeApparel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSizeApparel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSizeApparelForArrayConstraintsFromSetSizeApparel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $sizeApparelArraySizeApparelItem) {
            // validation for constraint: itemType
            if (!$sizeApparelArraySizeApparelItem instanceof \StructType\SizeApparel) {
                $invalidValues[] = is_object($sizeApparelArraySizeApparelItem) ? get_class($sizeApparelArraySizeApparelItem) : sprintf('%s(%s)', gettype($sizeApparelArraySizeApparelItem), var_export($sizeApparelArraySizeApparelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SizeApparel property can only contain items of type \StructType\SizeApparel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SizeApparel value
     * @throws \InvalidArgumentException
     * @param \StructType\SizeApparel[] $sizeApparel
     * @return \ArrayType\SizeApparelArray
     */
    public function setSizeApparel(array $sizeApparel = array())
    {
        // validation for constraint: array
        if ('' !== ($sizeApparelArrayErrorMessage = self::validateSizeApparelForArrayConstraintsFromSetSizeApparel($sizeApparel))) {
            throw new \InvalidArgumentException($sizeApparelArrayErrorMessage, __LINE__);
        }
        $this->SizeApparel = $sizeApparel;
        return $this;
    }
    /**
     * Add item to SizeApparel value
     * @throws \InvalidArgumentException
     * @param \StructType\SizeApparel $item
     * @return \ArrayType\SizeApparelArray
     */
    public function addToSizeApparel(\StructType\SizeApparel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SizeApparel) {
            throw new \InvalidArgumentException(sprintf('The SizeApparel property can only contain items of type \StructType\SizeApparel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SizeApparel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SizeApparel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SizeApparel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SizeApparel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SizeApparel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SizeApparel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SizeApparel
     */
    public function getAttributeName()
    {
        return 'SizeApparel';
    }
}
