<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'FobPointArray' => '\\ArrayType\\FobPointArray',
            'FobPoint' => '\\StructType\\FobPoint',
            'ApparelSizeArray' => '\\ArrayType\\ApparelSizeArray',
            'Dimension' => '\\StructType\\Dimension',
            'ProductPackage' => '\\StructType\\ProductPackage',
            'ShippingPackage' => '\\StructType\\ShippingPackage',
            'Specification' => '\\StructType\\Specification',
            'ProductCategory' => '\\StructType\\ProductCategory',
            'RelatedProduct' => '\\StructType\\RelatedProduct',
            'ProductKeyword' => '\\StructType\\ProductKeyword',
            'ProductMarketingPoint' => '\\StructType\\ProductMarketingPoint',
            'ServiceMessageArray' => '\\ArrayType\\ServiceMessageArray',
            'ServiceMessage' => '\\StructType\\ServiceMessage',
            'ApparelSize' => '\\StructType\\ApparelSize',
            'SizeApparelArray' => '\\ArrayType\\SizeApparelArray',
            'SizeApparel' => '\\StructType\\SizeApparel',
            'TaxCategoryArray' => '\\ArrayType\\TaxCategoryArray',
            'ImprintColorsArray' => '\\ArrayType\\ImprintColorsArray',
            'Color' => '\\StructType\\Color',
            'ProductPriceGroup' => '\\StructType\\ProductPriceGroup',
            'ProductPriceArray' => '\\ArrayType\\ProductPriceArray',
            'ProductPrice' => '\\StructType\\ProductPrice',
            'LocationDecorationArray' => '\\ArrayType\\LocationDecorationArray',
            'LocationDecoration' => '\\StructType\\LocationDecoration',
            'GetProductRequest' => '\\StructType\\GetProductRequest',
            'Product' => '\\StructType\\Product',
            'ProductMarketingPointArray' => '\\ArrayType\\ProductMarketingPointArray',
            'ProductKeywordArray' => '\\ArrayType\\ProductKeywordArray',
            'ProductCategoryArray' => '\\ArrayType\\ProductCategoryArray',
            'RelatedProductArray' => '\\ArrayType\\RelatedProductArray',
            'ProductPriceGroupArray' => '\\ArrayType\\ProductPriceGroupArray',
            'ProductPartArray' => '\\ArrayType\\ProductPartArray',
            'ProductPart' => '\\StructType\\ProductPart',
            'primaryColor' => '\\StructType\\PrimaryColor',
            'ColorArray' => '\\ArrayType\\ColorArray',
            'SpecificationArray' => '\\ArrayType\\SpecificationArray',
            'ProductPackagingArray' => '\\ArrayType\\ProductPackagingArray',
            'ShippingPackageArray' => '\\ArrayType\\ShippingPackageArray',
            'GetProductResponse' => '\\StructType\\GetProductResponse',
            'GetProductDateModifiedRequest' => '\\StructType\\GetProductDateModifiedRequest',
            'ProductDateModified' => '\\StructType\\ProductDateModified',
            'GetProductDateModifiedResponse' => '\\StructType\\GetProductDateModifiedResponse',
            'ProductDateModifiedArray' => '\\ArrayType\\ProductDateModifiedArray',
            'GetProductCloseOutRequest' => '\\StructType\\GetProductCloseOutRequest',
            'ProductCloseOut' => '\\StructType\\ProductCloseOut',
            'GetProductCloseOutResponse' => '\\StructType\\GetProductCloseOutResponse',
            'ProductCloseOutArray' => '\\ArrayType\\ProductCloseOutArray',
            'GetProductSellableRequest' => '\\StructType\\GetProductSellableRequest',
            'GetProductSellableResponse' => '\\StructType\\GetProductSellableResponse',
            'ProductSellableArray' => '\\ArrayType\\ProductSellableArray',
            'ProductSellable' => '\\StructType\\ProductSellable',
        );
    }
}
