<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetProductRequest StructType
 * @subpackage Structs
 */
class GetProductRequest extends AbstractStructBase
{
    /**
     * The wsVersion
     * Meta information extracted from the WSDL
     * - base: xsd:token
     * - maxLength: 64
     * - minLength: 1
     * - ref: ns3:wsVersion
     * @var string
     */
    public $wsVersion;
    /**
     * The id
     * Meta information extracted from the WSDL
     * - base: xsd:token
     * - maxLength: 64
     * - minLength: 1
     * - ref: ns3:id
     * @var string
     */
    public $id;
    /**
     * The password
     * Meta information extracted from the WSDL
     * - base: xsd:token
     * - maxLength: 64
     * - minLength: 1
     * - minOccurs: 0
     * - ref: ns3:password
     * @var string
     */
    public $password;
    /**
     * The localizationCountry
     * Meta information extracted from the WSDL
     * - base: xsd:token
     * - maxLength: 2
     * - minLength: 2
     * - ref: ns3:localizationCountry
     * @var string
     */
    public $localizationCountry;
    /**
     * The localizationLanguage
     * Meta information extracted from the WSDL
     * - base: xsd:token
     * - maxLength: 2
     * - minLength: 2
     * - ref: ns3:localizationLanguage
     * @var string
     */
    public $localizationLanguage;
    /**
     * The productId
     * Meta information extracted from the WSDL
     * - base: xsd:token
     * - maxLength: 64
     * - minLength: 1
     * - ref: ns3:productId
     * @var string
     */
    public $productId;
    /**
     * The partId
     * Meta information extracted from the WSDL
     * - base: xsd:token
     * - maxLength: 64
     * - minLength: 1
     * - minOccurs: 0
     * - ref: ns3:partId
     * @var string
     */
    public $partId;
    /**
     * The colorName
     * Meta information extracted from the WSDL
     * - base: xsd:token
     * - maxLength: 64
     * - minLength: 1
     * - minOccurs: 0
     * - ref: ns3:colorName
     * @var string
     */
    public $colorName;
    /**
     * The ApparelSizeArray
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: ns3:ApparelSizeArray
     * @var \ArrayType\ApparelSizeArray
     */
    public $ApparelSizeArray;
    /**
     * Constructor method for GetProductRequest
     * @uses GetProductRequest::setWsVersion()
     * @uses GetProductRequest::setId()
     * @uses GetProductRequest::setPassword()
     * @uses GetProductRequest::setLocalizationCountry()
     * @uses GetProductRequest::setLocalizationLanguage()
     * @uses GetProductRequest::setProductId()
     * @uses GetProductRequest::setPartId()
     * @uses GetProductRequest::setColorName()
     * @uses GetProductRequest::setApparelSizeArray()
     * @param string $wsVersion
     * @param string $id
     * @param string $password
     * @param string $localizationCountry
     * @param string $localizationLanguage
     * @param string $productId
     * @param string $partId
     * @param string $colorName
     * @param \ArrayType\ApparelSizeArray $apparelSizeArray
     */
    public function __construct($wsVersion = null, $id = null, $password = null, $localizationCountry = null, $localizationLanguage = null, $productId = null, $partId = null, $colorName = null, \ArrayType\ApparelSizeArray $apparelSizeArray = null)
    {
        $this
            ->setWsVersion($wsVersion)
            ->setId($id)
            ->setPassword($password)
            ->setLocalizationCountry($localizationCountry)
            ->setLocalizationLanguage($localizationLanguage)
            ->setProductId($productId)
            ->setPartId($partId)
            ->setColorName($colorName)
            ->setApparelSizeArray($apparelSizeArray);
    }
    /**
     * Get wsVersion value
     * @return string|null
     */
    public function getWsVersion()
    {
        return $this->wsVersion;
    }
    /**
     * Set wsVersion value
     * @param string $wsVersion
     * @return \StructType\GetProductRequest
     */
    public function setWsVersion($wsVersion = null)
    {
        // validation for constraint: string
        if (!is_null($wsVersion) && !is_string($wsVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($wsVersion, true), gettype($wsVersion)), __LINE__);
        }
        // validation for constraint: maxLength(64)
        if (!is_null($wsVersion) && mb_strlen($wsVersion) > 64) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 64', mb_strlen($wsVersion)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($wsVersion) && mb_strlen($wsVersion) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($wsVersion)), __LINE__);
        }
        $this->wsVersion = $wsVersion;
        return $this;
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\GetProductRequest
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        // validation for constraint: maxLength(64)
        if (!is_null($id) && mb_strlen($id) > 64) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 64', mb_strlen($id)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($id) && mb_strlen($id) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\GetProductRequest
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        // validation for constraint: maxLength(64)
        if (!is_null($password) && mb_strlen($password) > 64) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 64', mb_strlen($password)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($password) && mb_strlen($password) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get localizationCountry value
     * @return string|null
     */
    public function getLocalizationCountry()
    {
        return $this->localizationCountry;
    }
    /**
     * Set localizationCountry value
     * @param string $localizationCountry
     * @return \StructType\GetProductRequest
     */
    public function setLocalizationCountry($localizationCountry = null)
    {
        // validation for constraint: string
        if (!is_null($localizationCountry) && !is_string($localizationCountry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($localizationCountry, true), gettype($localizationCountry)), __LINE__);
        }
        // validation for constraint: maxLength(2)
        if (!is_null($localizationCountry) && mb_strlen($localizationCountry) > 2) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 2', mb_strlen($localizationCountry)), __LINE__);
        }
        // validation for constraint: minLength(2)
        if (!is_null($localizationCountry) && mb_strlen($localizationCountry) < 2) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 2', mb_strlen($localizationCountry)), __LINE__);
        }
        $this->localizationCountry = $localizationCountry;
        return $this;
    }
    /**
     * Get localizationLanguage value
     * @return string|null
     */
    public function getLocalizationLanguage()
    {
        return $this->localizationLanguage;
    }
    /**
     * Set localizationLanguage value
     * @param string $localizationLanguage
     * @return \StructType\GetProductRequest
     */
    public function setLocalizationLanguage($localizationLanguage = null)
    {
        // validation for constraint: string
        if (!is_null($localizationLanguage) && !is_string($localizationLanguage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($localizationLanguage, true), gettype($localizationLanguage)), __LINE__);
        }
        // validation for constraint: maxLength(2)
        if (!is_null($localizationLanguage) && mb_strlen($localizationLanguage) > 2) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 2', mb_strlen($localizationLanguage)), __LINE__);
        }
        // validation for constraint: minLength(2)
        if (!is_null($localizationLanguage) && mb_strlen($localizationLanguage) < 2) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 2', mb_strlen($localizationLanguage)), __LINE__);
        }
        $this->localizationLanguage = $localizationLanguage;
        return $this;
    }
    /**
     * Get productId value
     * @return string|null
     */
    public function getProductId()
    {
        return $this->productId;
    }
    /**
     * Set productId value
     * @param string $productId
     * @return \StructType\GetProductRequest
     */
    public function setProductId($productId = null)
    {
        // validation for constraint: string
        if (!is_null($productId) && !is_string($productId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productId, true), gettype($productId)), __LINE__);
        }
        // validation for constraint: maxLength(64)
        if (!is_null($productId) && mb_strlen($productId) > 64) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 64', mb_strlen($productId)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($productId) && mb_strlen($productId) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($productId)), __LINE__);
        }
        $this->productId = $productId;
        return $this;
    }
    /**
     * Get partId value
     * @return string|null
     */
    public function getPartId()
    {
        return $this->partId;
    }
    /**
     * Set partId value
     * @param string $partId
     * @return \StructType\GetProductRequest
     */
    public function setPartId($partId = null)
    {
        // validation for constraint: string
        if (!is_null($partId) && !is_string($partId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($partId, true), gettype($partId)), __LINE__);
        }
        // validation for constraint: maxLength(64)
        if (!is_null($partId) && mb_strlen($partId) > 64) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 64', mb_strlen($partId)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($partId) && mb_strlen($partId) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($partId)), __LINE__);
        }
        $this->partId = $partId;
        return $this;
    }
    /**
     * Get colorName value
     * @return string|null
     */
    public function getColorName()
    {
        return $this->colorName;
    }
    /**
     * Set colorName value
     * @param string $colorName
     * @return \StructType\GetProductRequest
     */
    public function setColorName($colorName = null)
    {
        // validation for constraint: string
        if (!is_null($colorName) && !is_string($colorName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($colorName, true), gettype($colorName)), __LINE__);
        }
        // validation for constraint: maxLength(64)
        if (!is_null($colorName) && mb_strlen($colorName) > 64) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 64', mb_strlen($colorName)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($colorName) && mb_strlen($colorName) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($colorName)), __LINE__);
        }
        $this->colorName = $colorName;
        return $this;
    }
    /**
     * Get ApparelSizeArray value
     * @return \ArrayType\ApparelSizeArray|null
     */
    public function getApparelSizeArray()
    {
        return $this->ApparelSizeArray;
    }
    /**
     * Set ApparelSizeArray value
     * @param \ArrayType\ApparelSizeArray $apparelSizeArray
     * @return \StructType\GetProductRequest
     */
    public function setApparelSizeArray(\ArrayType\ApparelSizeArray $apparelSizeArray = null)
    {
        $this->ApparelSizeArray = $apparelSizeArray;
        return $this;
    }
}
